import http.client

collegefootballdata_api_key = "Bearer 2KJcGkV386h7MaeZJ8ls0CHlyH1rTlP4eALxgbN9k+h+DTaDZcN6wj0FpP6u+rTE"
collegefootballdata_api_url = "https://api.collegefootballdata.com"
collegefootballdata_host = "api.collegefootballdata.com"

class CFDB_Fetcher():
	def FetchData(self, url, parameters):
		fullUrl = url
		if parameters != None:
			fullUrl += "?"
			for key in parameters:
#				if isinstance(parameters[key], int) == True:
#					fullUrl += key + "=" + int(parameters[key]) + "&"
#				else:
				fullUrl += str(key) + "=" + str(parameters[key]) + "&"
			fullUrl = fullUrl.rstrip(fullUrl[-1])
		
		conn = http.client.HTTPSConnection(collegefootballdata_host)

		headers = {
			'accept' : 'application/json',
			'Authorization' : collegefootballdata_api_key
		}
		conn.request("GET", fullUrl, headers=headers)

		response = conn.getresponse()
		data = response.read()

		return data.decode("utf-8")

	def FetchGames(self, year, week=0, seasonType="", team="", home="", away="", conference="", division="", id=0):
		parameters = {
			"year" : year
		}
		if week != 0:
			parameters["week"] = week
		if seasonType != "":
			parameters["seasonType"] = seasonType
		if team != "":
			parameters["team"] = team
		if home != "":
			parameters["home"] = home
		if away != "":
			parameters["away"] = away
		if conference != "":
			parameters["conference"] = conference
		if division != "":
			parameters["division"] = division
		if id != 0:
			parameters["id"] = id

		return self.FetchData("/games", parameters)

	def FetchScoreboard(self, classification="", conference=""):
		parameters = {}
		if classification != "":
			parameters["classification"] = classification
		if conference != "":
			parameters["conference"] = conference

		return self.FetchData("/scoreboard", parameters)

	def FetchRecords(self, year, team="", conference=""):
		parameters = {
			"year" : year
		}
		if team != "":
			parameters["team"] = team
		if conference != "":
			parameters["conference"] = conference

		return self.FetchData("/records", parameters)

	def FetchCalendar(self, year):
		parameters = {
			"year" : year
		}

		return self.FetchData("/calendar", parameters)

	def FetchTeams(self, conference=""):
		parameters = {}
		if conference != "":
			parameters["conference"] = conference

		return self.FetchData("/teams", parameters)

	def FetchFBSTeams(self, year=0):
		parameters = {}
		if year != 0:
			parameters["year"] = year

		return self.FetchData("/teams/fbs", year)

	def FetchTeamMatchup(self, team1, team2, minYear=0, maxYear=0):
		parameters = {
			"team1" : team1,
			"team2" : team2
		}
		if minYear != 0:
			parameters["minYear"] = minYear
		if maxYear != 0:
			parameters["maxYear"] = maxYear

		return self.FetchData("/teams/matchup", parameters)

	def FetchConferences(self):
		return self.FetchData("/conferences", None)

	def FetchVenues(self):
		return self.FetchData("/venues", None)

	def FetchRankings(self, year, week=0, seasonType=""):
		parameters = {
			"year" : year
		}
		if week != 0:
			parameters["week"] = week
		if seasonType != "":
			parameters["seasonType"] = seasonType

		return self.FetchData("/rankings", parameters)

	def FetchLines(self, gameId=0, year=0, week=0, seasonType="", team="", home="", away="", conference=""):
		parameters = {}
		if gameId != 0:
			parameters["gameId"] = gameId
		if year != 0:
			parameters["year"] = year
		if week != 0:
			parameters["week"] = week
		if seasonType != "":
			parameters["seasonType"] = seasonType
		if team != "":
			parameters["team"] = team
		if home != "":
			parameters["home"] = home
		if away != "":
			parameters["away"] = away
		if conference != "":
			parameters["conference"] = conference

		return FetchData("/lines", parameters)

